"""HTML Parsers

This file is a part of Bookmarks database and Internet robot.

"""

__author__ = "Oleg Broytman <phd@phdru.name>"
__copyright__ = "Copyright (C) 2014 PhiloSoft Design"
__license__ = "GNU GPL"


from .bkmk_parse_html import parse_filename


def main():
   import sys
   from .bkmk_parse_html import universal_charset

   l = len(sys.argv)
   if l == 3:
      filename = sys.argv[1]
      charset = sys.argv[2]
   elif l == 2:
      filename = sys.argv[1]
      charset = universal_charset
   else:
      sys.exit("Usage: main filename [charset]")

   parser = parse_filename(filename, charset, log=lambda s: sys.stdout.write(s + '\n'))
   print "   refresh:", parser.refresh
   print "   icon   :", parser.icon

if __name__ == '__main__':
    main()
